#ifndef __sky_modelH__
#define __sky_modelH__

#include <string>
#include <vector>
#include "camera.h"

class cSkyModel
{
public:
	cSkyModel(IDirect3DDevice9* device, Camera* TheCamera);
	~cSkyModel();
	
	bool CreateCube( char *Texturename );
	bool render(bool wireframe);

private:
	bool loadCubeTexture(char *filename);

private:
	
	IDirect3DDevice9*				Device;
	D3DXMATRIX						_world;
	IDirect3DVertexBuffer9*			_vb;
	IDirect3DIndexBuffer9*			_ib;
	
	// ,     
	UINT					m_width;
    UINT					m_height;
    UINT					m_mipLevels;
    UINT					m_d3dUsage;
    D3DFORMAT				m_d3dFormat;
    D3DPOOL					m_d3dPool;
    DWORD					m_d3dFilter;
    DWORD					m_d3dMipFilter;
    D3DCOLOR				m_d3dColorKey;
    D3DXIMAGE_INFO			m_d3dImageInfo;
    PALETTEENTRY*			m_pPalette;
	LPDIRECT3DCUBETEXTURE9	m_pCubeTexture;


	//   
	Camera*							_TheCamera;
	ID3DXEffect*					_SkyBoxEffect;
	D3DXHANDLE						_SkyBoxTechHandle;
	D3DXHANDLE						_WorldViewProjHandle;
	D3DXHANDLE						_TexHandle;
	D3DXMATRIX						_WorldViewProj;

};

#endif //CSKYBOX_H